function FxDTSBrick::OnSquadLeaderAvalable(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	%this.processInputEvent("OnSquadLeaderAvalable", %client);
}

registerInputEvent(fxDTSBrick, "OnSquadLeaderAvalable", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);

function FxDTSBrick::OnSquadLeaderUnavalable(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	%this.processInputEvent("OnSquadLeaderUnavalable", %client);
}

registerInputEvent(fxDTSBrick, "OnSquadLeaderUnavalable", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);


function FxDTSBrick::CheckSquadLeaderAvalable(%this, %client, %squad) //Up to three squads with 4 people each (including leaders)
{
	if(%squad == 0)
	{
		serverCmdLeaveSquad (%client);
	}
	%count = ClientGroup.getCount();
	for(%cl = 0; %cl < %count; %cl++)
	{
		%clientB = ClientGroup.getObject(%cl);
		if(!%clientB.isSquadLeader[%squad])
		{
			%this.OnSquadLeaderAvalable(%client);
		}
		else
		{
			%this.OnSquadLeaderUnavalable(%client);
		}
	}
	
}

registerOutputEvent("FxDTSBrick", "CheckSquadLeaderAvalable", "list None 0 Alpha 1 Bravo 2 Charlie 3 Delta 4");

function GameConnection::MakeSquadLeader(%client, %squad)
{
	if(%client.squad != %squad)
	{
		return messageClient(%client, '', "\c0ERROR\c6: You are not currently a member of that squad!");
	}

	%count = ClientGroup.getCount();
	for(%cl = 0; %cl < %count; %cl++)
	{
		%client2 = ClientGroup.getObject(%cl);
		if(%client2.squad == %squad && %client2.isSquadLeader)
		{
			return messageClient(%client, '', "\c0ERROR\c6: Selected squad already has a leader!");
		}
	}

	%client.isSquadLeader = 1;
	%squadName = getWord($server::Squads, %squad);
	if($server::AnnounceSquad)
		announce("\c2"@%client.name@" is now squad leader of "@%squadName@".");
}

registerOutputEvent("GameConnection", "MakeSquadLeader", "list None 0 Alpha 1 Bravo 2 Charlie 3 Delta 4");

function GameConnection::JoinSquad(%client, %squad)
{
	if(%squad == 0)
	{
		return serverCmdLeaveSquad (%client);
	}

	if(%client.squad == %squad)
		return messageClient(%client, '', "\c0ERROR\c6: You are already in that squad!");

	if($server::SquadMembers[%squad] < $server::MaxSquadMembers)
	{
		%name = getWord($server::Squads, %squad);
		messageClient(%client, '', "\c6You have joined "@%name@" Squad. Make sure you obey your leader and keep him alive!");
		$server::SquadMembers[%squad]++;
		%client.squad = %squad;
		%squadName = getWord($server::Squads, %squad);
		if($server::AnnounceSquad)
			announce("\c2"@%client.name@"\c6 has joined squad "@%squadName);
	}
	else
	{
		messageClient(%client, '', "\c6Squad is already full. You cannot join.");
	}
}

registerOutputEvent("GameConnection", "JoinSquad", "list None 0 Alpha 1 Bravo 2 Charlie 3 Delta 4");

function Player::moveToSquadLeader(%obj)
{
	%client = %obj.client;
	if(%client.isSquadLeader)
	{
		%obj.leaderSpawn = false;
		return;
	}
	for(%cw = 0; %cw < ClientGroup.getCount(); %cw++)
	{
		%cl2 = ClientGroup.getObject(%cw);
		if(isObject(%cl2) && %cl2.isSquadLeader && %cl2.squad == %client.squad && %client.bl_id != %cl2.bl_id)
		{
			%t = %cl2.player.getTransform();
		}
	}
	%obj.setTransform(%t);
}

registerOutputEvent("Player", "MoveToSquadLeader");