exec("./events.cs");
exec("./help.cs");

$squadMod::Version = 1.3;
$server::Squads = "None Alpha Bravo Charlie Delta";
$server::SquadMembers[0] = 0;
$server::SquadMembers[1] = 0;
$server::SquadMembers[2] = 0;
$server::SquadMembers[3] = 0;
$server::MaxSquadMembers = 6;
$server::SpottedPlayerMessage[0] = "Hostile troops, incoming!";
$server::SpottedPlayerMessage[1] = "Enemy ground forces, spotted!";
$server::SpottedPlayerMessage[2] = "Enemy is approaching on foot, over.";
$server::SpottedPlayerMessage[3] = "Hostile infantry, spotted!";
$server::SpottedVehicleMessage[0] = "Enemy in vehicle, over.";
$server::SpottedVehicleMessage[1] = "Hostile vehicle spotted!";
$server::SpottedVehicleMessage[2] = "Enemy approaching vehicle sighted!";
$server::SpottedVehicleMessage[3] = "Picking up enemy vehicle targets!";
$server::Order["Attack"] = "Attack this position (\c0Red \c6Smoke)!";
$server::Order["Defend"] = "Defend this position at all costs (\c2Green \c6Smoke)!";
$server::Order["Move"] = "Move to this position (\c6White \c6Smoke)";
$server::SquadColors = "0_2_0 1_1_0 0_1_1 0_0_1";

RTB_registerPref("Allow /JoinSquad Command", "EV0_'s Squad Mod", "$server::AllowJoinSquad", "bool", "Server_SquadMod", "true", 0, 0, 0);
RTB_registerPref("Allow /LeaveSquad Command", "EV0_'s Squad Mod", "$server::AllowLeaveSquad", "bool", "Server_SquadMod", "true", 0, 0, 0);
RTB_registerPref("Allow /SquadLeader Command", "EV0_'s Squad Mod", "$server::AllowSquadLeader", "bool", "Server_SquadMod", "true", 0, 0, 0);
RTB_registerPref("Announce Join/Leave Squad", "EV0_'s Squad Mod", "$server::AnnounceSquad", "bool", "Server_SquadMod", "true", 0, 0, 0);
RTB_registerPref("Max Squad Members", "EV0_'s Squad Mod", "$server::MAxSquadMemberes", "int 0 10", "Server_SquadMod", "6", 0, 0, 0);


//Support Functions

function GameConnection::LeaveSquad(%client)
{
	serverCmdLeaveSquad(%client);
}

function GameConnection::ResignSquadLeader(%client)
{
	serverCmdLeaveSquad(%client);
}

//Main Functions
package Squads_OnJoin
{
	function GameConnection::AutoAdminCheck(%client)
	{
		messageClient(%client, '', "c6This server is running \c2EV0_'s Squad Mod\c4 v"@$SquadMod::Version@"\c6, type /squadHelp for help.");
		parent::AutoAdminCheck(%client);
	}
	function GameConnection::Oncliententergame(%client)
	{
		%client.squad = "";
		%client.squadLeader = 0;
		parent::OnClientEnterGame(%client);
	}
};

function serverCmdJoinSquad (%client, %squad)
{
	if(!$server::AllowJoinSquad)
		return;
	%client.JoinSquad(%squad);
}

function serverCmdLeaveSquad (%client)
{
	if(!$server::AllowLeaveSquad)
		return;
	%squad = %client.Squad;
	%client.Squad = "";
	%client.SquadLeader = 0; //Support in case the client is leader of squad he's leaving.
	messageClient(%client, '', "\c6You have left your squad.");
	$server::SquadMembers[%squad]--;
}

function serverCmdViewSquadMembers (%client)
{
	messageClient(%client, '', "\c2Alpha\c6:");
	%count = ClientGroup.getCount();
	for (%cw = 0; %cw < %count; %cw++)
    {
		%client2 = ClientGroup.getObject(%cw);
		if(%client2.squad == 1 && !%client2.isSquadLeader)
		{
			messageCLient(%client, '', "\c6-- "@%client2.name);
		}
		if(%client2.squad == 1 && %client2.isSquadLeader)
		{
			messageClient(%client, '', "\c6-- (\c2LEADER\c6) "@%client2.name);
		}
	}
	messageClient(%client, '', "\c3Bravo\c6:");
	for (%cw1 = 0; %cw1 < %count; %cw1++)
	{
		%client3 = ClientGroup.getObject(%cw1);
		if(%client3.squad == 2 && !%client3.isSquadLeader)
		{
			messageClient(%client, '', "\c6-- "@%client3.name);
		}
		if(%client3.squad == 2 && %client3.isSquadLeader)
		{
			messageClient(%client, '', "\c6-- (\c2LEADER\c6) "@%client3.name);
		}
	}
	messageClient(%client, '', "\c4Charlie\c6:");
	for (%cw2 = 0; %cw2 < %count; %cw2++)
	{
		%client4 = ClientGroup.getObject(%cw2);
		if(%client4.squad == 3 && !%client4.isSquadLeader)
		{
			messageClient(%client, '', "\c6-- "@%client4.name);
		}
		if(%client4.squad == 3 && %client4.isSquadLeader)
		{
			messageClient(%client, '', "\c6-- (\c2LEADER\c6) "@%client4.name);
		}
	}
	messageClient(%client, '', "\c1Delta\c6:");
	for (%cw3 = 0; %cw3 < %count; %cw3++)
	{
		%client5 = ClientGroup.getObject(%cw3);
		if(%client5.squad == 4 && !%client5.isSquadLeader)
		{
			messageClient(%client, '', "\c6-- "@%client5.name);
		}
		if(%client5.squad == 4 && %client5.isSquadLeader)
		{
			messageClient(%client, '', "\c6-- (\c2LEADER\c6) "@%client5.name);
		}
	}
}

function serverCmdResignSquadLeader(%client)
{
	if(!$server::AllowLeaveSquad)
		return;
	%squadName = getWord($server::Squads, %client.squad);
	announce("\c2"@%client.name@" \c6is no longer squad leader for squad "@%squadname);
	%client.isSquadLeader = 0;
}

function serverCmdAssignSquad(%client, %target, %squad)
{
	if(!%client.isSuperAdmin)
		return;

	%target = findclientbyname(%target);
	%target.JoinSquad(%squad);
	%squadName = getWord($server::Squads, %squad);
	announce("\c2"@%client.name@" \c6has assigned \c2"@%target.name@" \c6to Squad "@%squadName@".");
}

function serverCmdAssignSquadLeader(%client, %target, %squad)
{
	if(!%client.isSuperAdmin)
		return;
	
	%target = findclientbyname(%target);
	if(%target.squad != %squad)
	{
		%target.leaveSquad();
		%target.joinSquad(%squad);
	}
	%target.MakeSquadLeader(%squad);
	announce("\c2"@%client.name@" has assigned \c2"@%target.name@" as Squad Leader for Squad "@%squadName@".");
	echo(%client.name@" assigned "@%target.name@" as Squad Leader for Squad "@%squadName@".");
}

function serverCmdClearSquad (%client, %squad)
{
	if(!%client.isSuperAdmin)
		return;
	if(%squad $= "")
		return;

	%squadName = getWord($server::Squads, %squad);
	announce("\c2"@%client.name@" \c6has cleared the members of \c2"@%squadName@" Squad\c6.");
	%count = ClientGroup.getCount();
	for(%cw = 0; %cw < %count; %cw++)
	{
		%client2 = ClientGroup.getObject(%cw);
		if(%client2.squad == %squad)
		{
			%client2.squad = 0;
		}
		if(%client2.squad == %squad && %client2.isSquadLeader)
		{
			%client2.isSquadLeader = false;
			%client2.squad = 0;
		}
	}
	echo(%client.name@" cleared Squad "@%squadName);
}

function serverCmdClearALLSquads (%client)
{
	if(!%client.isSuperAdmin)
		return;

	announce("\c2"@%client.name@" \c2has cleared ALL squads!");
	%count = ClientGroup.getCount();
	for(%cw = 0; %cw < %count; %cw++)
	{
		%client2 = ClientGroup.getObject(%cw);
		if(%client2.squad !$= "" || !%client2.squad == 0)
		{
			%client.squad = 0;
			%client.isSquadLeader = false;
		}
	}
	echo(%client.name@" cleared all squads.");
}

package SquadChat
{
	function serverCmdMessageSent(%client, %msg)
	{
		if(%msg $= "")
			return;


		%Sub = getWord(%msg, 0);
		if(%sub $= "*S")
		{
			if(%client.squad $= "" || %client.squad == 0)
			{
				return messageClient(%client, '', "\c6You are not in a squad!");
			}
			%count = ClientGroup.getCount();
			for(%cw = 0; %cw < %count; %cw++)
			{
				%client2 = ClientGroup.getObject(%cw);
				if(%client2.squad == %client.squad)
				{
					%msg = StrReplace(%msg, "*S", "");
					messageClient(%client2, '', "\c6[\c1Squad\c6] \c3"@%client.name@"\c6: "@%msg);
					echo("SQUAD CHAT ("@%client.name@"): "@%msg);
				}
			}
		}
		else
		{
			parent::serverCmdMessageSent(%client, %msg);
		}
	}
};
activatePackage(SquadChat);

function getObjSpotted(%client)
{
	%eyePoint = %client.player.getEyePoint();
	%eyeVector = %client.player.getEyeVector();
	%raycast = containerRayCast(%eyePoint,vectorAdd(%eyePoint,vectorScale(%eyeVector,10)),($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType));
	%obj = firstWord(%raycast);
	if(isObject(%obj))
	{
		if(%obj.getclassName() $= "Player")
			%type = 0;
		if(%obj.getClassName() $= "Vehicle")
			%type = 1;

		return %type;
	}
}

function serverCmdSpotted(%client)
{
	%type = getObjSpotted(%client);
	%random = getRandom(0,3);
	if(%type == 0)
	{
		serverCmdTeamMessageSent(%client, $server::SpottedPlayerMessage[%random]);
	}
	if(%type == 1)
	{
		serverCmdTeamMessageSent(%client, $server::SpottedVehicleMessage[%random]);
	}
}

function serverCmdApplySquadLeader(%client)
{
	if(%client.squad $= "" || %client.squad == 0)
		return messageClient(%client, '', "\c0ERROR\c6: You are not currently in a squad!");
	%client.makeSquadLeader(%client.squad);
}

function serverCmdSquadOrder(%client, %order)
{
	if(!%client.isSquadLeader || %client.squad == 0 || %client.squad $= "")
	{
		return messageClient(%client, '', "\c0ERROR\c6: Eigher you are not in a squad, or are not squad leader!");
	}
	if(%order $= "")
	{
		return messageCLient(%client, '', "\c0ERROR\c6: No order specified!");
	}


	if(%order $= "attack")
	{
		%projectile = "gc_SmokeGrenadeRProjectile";
		%message = "Attack";
	}
	if(%order $= "defend")
	{
		%projectile = "gc_SmokeGrenadeGProjectile";
		%message = "Defend";
	}
	if(%order $= "move")
	{
		%projectile = "gc_SmokeGrenadeWProjectile";
		%message = "Move";
	}
	%obj = %client.player;
	%client.centerPrint("\c6Order sent to squadmates.", 2);
	%p = new Projectile()
	{
		dataBlock = %projectile;
		initialVelocity = "0 0 30";
		initialPosition = %obj.getMuzzlePoint(0);
		sourceObject = %obj;
		sourceSlot = 0;
		client = %client;
	};
	for(%cw = 0; %cw < ClientGroup.getCount(); %cw++)
	{
		%cl2 = ClientGroup.getObject(%cw);
		if(%cl2.Squad == %client.squad && %cl2.bl_id != %client.bl_id)
		{
			messageClient(%cl2, 'msgAdminForce', "\c2NEW ORDER RECIEVED\c6: "@$server::Order[%message]);
		}
	}
	messageClient(%client, 'msgAdminForce', "\c2ORDER SENT\c6: "@$server::Order[%message]);
}

function serverCmdcallHelp(%client)
{
	%player = %client.player;
	%p = new Projectile()
	{
		dataBlock = gc_FlareGunProjectile;
		initialVelocity = "0 0 50";
		initialPosition = %player.getMuzzlePoint(0);
		sourceObject = %player;
		sourceSlot = 0;
		client = %client;
	};
	%player.playThread(2, activate);
	for(%i = 0; %i < 3; %i++)
	{
		gc_flaregunTrailParticle.colors[%i] = "1 0 0";
	}
}

function serverCmdSquadLeader(%client)
{
	if(!$server::AllowSquadLeader)
	{
		return messageClient(%client, '', "\c0ERROR\c6: /squadLeader is currently disabled!");
	}
	if(%client.squad == 0 || %client.squad $= "")
	{
		messageClient(%client, '', "\c0ERROR\c6: You are not in a squad!");
	}
	if(%client.isSquadLeader)
	{
		messageClient(%client, '', "\c0ERROR\c6: You are already a squad leader!");
	}

	for(%cw = 1; %cw < ClientGroup.getCount(); %cw++)
	{
		%cl2 = ClientGroup.getObject(%cw);
		if(%cl2.squad == %client.squad && %cl2.isSquadLeader)
		{
			messageClient(%client, '', "\c6There is already a squad leader. However, he has been notified and requested to resign.");
			messageCLient(%cl2, 'msgAdminForce', "\c0NOTICE\c6: "@%client.name@" would like to become squad leader of your squad.");
			messageClient(%cl2, '', "\c6To accept, type \c3/resignSquadleader\c6.");
			return;
		}
	}
	%client.makeSquadLeader(%client.squad);
}


package SquadLeaderSpawn
{
	function GameConnection::createPlayer(%this,%t)
	{
		if(!%this.leaderspawn)
		{
			return parent::createPlayer(%this, %t);
		}
		if(%this.isSquadLeader)
		{
			parent::createPlayer(%this, %t);
			%this.leaderSpawn = false;
			return;
		}
		for(%cw = 0; %cw < ClientGroup.getCount(); %cw++)
		{
			%cl2 = ClientGroup.getObject(%cw);
			if(isObject(%cl2) && %cl2.isSquadLeader && %cl2.squad == %this.squad && %client.bl_id != %cl2.bl_id)
			{
				%t = %cl2.player.getTransform();
			}
		}
		Parent::createPlayer(%this,%t);
	}
};
activatepackage(SquadLeaderSpawn);

function serverCmdToggleLeaderSpawn(%client)
{
	if(%client.isSquadLeader || %client.squad == 0 || %client.squad $= "")
	{
		return %client.leaderSpawn = false;
	}
	if(%client.leaderspawn == false || %client.leaderSpawn $= "")
	{
		%client.leaderspawn = true;
		messageClient(%client, '', "\c6Squad Leader Spawnpoint turned \c2ON\c6.");
	}
	else
	{
		%client.leaderSpawn = false;
		messageClient(%client, '', "\c6Squad Leader Spawnpoint turned \c0OFF\c6.");
	}
}

package AutoSquadLeader
{
	function Player::JoinSquad(%obj, %squad)
	{
		parent::JoinSquad(%obj, %squad);
		%count = 0;
		%client = %obj.client;
		for(%cw = 0; %cw < ClientGroup.getCount(); %cw++)
		{
			%cl2 = ClientGroup.getObject(%cw);
			if(%cl2.squad == %squad)
			{
				%count++;
			}
		}
		if(%count == 0)
		{
			%client.makeSquadLeader(%sqaud);
		}
		else if (%count > 0)
		{
			return;
		}
	}
};
activatePackage(AutoSquadLeader);